Bug 1566070 - Obsoletes takes effect on install but not on update with dnf (yum-deprecated works)
Summary: Obsoletes takes effect on install but not on update with dnf (yum-deprecated ...
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: dnf
Version: 30
Hardware: All
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Jaroslav Mracek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1553646 1569558 1665531 (view as bug list)
Depends On:
Blocks: F28BetaFreezeException 1553646
TreeView+ depends on / blocked
 
Reported: 2018-04-11 13:10 UTC by Kamil Dudka
Modified: 2019-09-06 16:00 UTC (History)
38 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1553646
Environment:
Last Closed:


Attachments (Terms of Use)

Description Kamil Dudka 2018-04-11 13:10:36 UTC
The following construction in a spec file removes 32bit build of an updated 64bit package while using 'dnf install' or 'yum-deprecated update':

    Obsoletes: %{name} < %{version}-%{release}

... but surprisingly it does not work with 'dnf update' and friends.  Also the output of 'dnf install' is misleading because it does not inform the user that the 32bit build of the package is going to be removed.  This is a regression compared to yum-deprecated.


+++ This bug was initially created as a clone of Bug #1553646 +++

# dnf install nss-pem-1.0.3-9.fc28
Dependencies resolved.
==============================================================================
 Package       Arch         Version               Repository             Size
==============================================================================
Upgrading:
 nss-pem       x86_64       1.0.3-9.fc28          updates-testing        80 k

Transaction Summary
==============================================================================
Upgrade  1 Package

Total download size: 80 k
Is this ok [y/N]:


# dnf update nss-pem-1.0.3-9.fc28 
Dependencies resolved.

 Problem: package nss-pem-1.0.3-9.fc28.x86_64 conflicts with nss-pem(x86-32) < 1.0.3-9.fc28 provided by nss-pem-1.0.3-6.fc27.i686
  - cannot install the best update candidate for package nss-pem-1.0.3-6.fc27.x86_64
  - problem with installed package nss-pem-1.0.3-6.fc27.i686
==============================================================================
 Package       Arch         Version               Repository             Size
==============================================================================
Skipping packages with conflicts:
(add '--best --allowerasing' to command line to force their upgrade):
 nss-pem       x86_64       1.0.3-9.fc28          updates-testing        80 k

Transaction Summary
==============================================================================
Skip  1 Package

Nothing to do.
Complete!

Comment 1 Kamil Dudka 2018-04-20 07:55:33 UTC
*** Bug 1569558 has been marked as a duplicate of this bug. ***

Comment 2 Kamil Dudka 2018-05-02 09:33:25 UTC
Any news on this?  People are hitting this bug while updating to Fedora 28.

Comment 3 Jos de Kloe 2018-05-03 07:49:21 UTC
I am seeing another maybe related issue with nss-pem when trying to upgrade to f28:

sudo dnf system-upgrade download --refresh --releasever=28
Before you continue ensure that your system is fully upgraded by running "dnf --refresh upgrade". Do you want to continue [y/N]: y
Last metadata expiration check: 0:00:00 ago on Thu 03 May 2018 09:47:00 AM CEST.
Error: 
 Problem: nss-pem-1.0.3-6.fc27.i686 has inferior architecture
  - nss-pem-1.0.3-6.fc27.x86_64 does not belong to a distupgrade repository
  - problem with installed package nss-pem-1.0.3-6.fc27.i686

if I then try to temporarily remove nss-pem I get this:

sudo dnf remove nss-pem
Error: 
 Problem: The operation would result in removing the following protected packages: sudo

any workarounds known to this issue?

Comment 4 Jos de Kloe 2018-05-03 07:55:34 UTC
additional info:
nss-pem-1.0.3-6.fc27.x86_64 and nss-pem-1.0.3-6.fc27.i686 are both installed on my system.

Comment 5 Jos de Kloe 2018-05-03 08:03:13 UTC
Another discussion of the same problem seems to be in this bug: https://bugzilla.redhat.com/show_bug.cgi?id=1553646

The workaround presented there works for me, i.e. upgrade to th f28 version of nss-pem before starting the upgrade itself.

Comment 6 Kamil Dudka 2018-05-03 10:27:39 UTC
(In reply to Jos de Kloe from comment #5)
> The workaround presented there works for me, i.e. upgrade to th f28 version
> of nss-pem before starting the upgrade itself.

Yes, this workaround is known to work reliably.  Sorry for the inconveniences!

Comment 7 Vincent Poinot 2018-05-12 07:48:55 UTC
Does it mean that there will be no fix for this bug and that we have to resort to the workaround in order to upgrade to F28?
(Just asking because I see this bug is not even assigned at the time of writing, although it is probably blocking many people from smoothly upgrading).

Comment 8 John Freed 2018-05-15 06:30:03 UTC
At the very list, this bug (and workaround) should urgently be referenced here:

https://fedoraproject.org/wiki/Common_F28_bugs#Upgrade_issues

This bug blocks upgrades for anyone who has installed Wine.

Comment 9 Kamil Páral 2018-05-15 08:31:06 UTC
(In reply to John Freed from comment #8)
> This bug blocks upgrades for anyone who has installed Wine.

I tested it and it works fine with --allowerasing, wine is kept and is usable in the upgraded system.

Comment 10 Antonin 2018-05-23 07:59:31 UTC
Upgrade of my system to F28 is still blocked. Will it be fixed?

Comment 11 Kamil Dudka 2018-05-23 08:47:15 UTC
(In reply to Antonin from comment #10)
> Upgrade of my system to F28 is still blocked.

Please run the following command to unblock the upgrade of your system:

# dnf install nss-pem-1.0.3-9.fc28

Comment 12 Antonin 2018-05-23 08:58:13 UTC
(In reply to Kamil Dudka from comment #11)
> (In reply to Antonin from comment #10)
> > Upgrade of my system to F28 is still blocked.
> 
> Please run the following command to unblock the upgrade of your system:
> 
> # dnf install nss-pem-1.0.3-9.fc28

But I think it will change status of the nss-pem package from "installed as dependency" to "user installed". If possible I would avoid it.

Comment 13 Marek Blaha 2018-05-23 10:37:40 UTC
(In reply to Antonin from comment #12)
> > # dnf install nss-pem-1.0.3-9.fc28
> 
> But I think it will change status of the nss-pem package from "installed as
> dependency" to "user installed". If possible I would avoid it.

You can run # dnf mark remove nss-pem to mark it as dependency again.

Comment 14 Kamil Dudka 2018-05-23 11:09:36 UTC
(In reply to Marek Blaha from comment #13)
> You can run # dnf mark remove nss-pem to mark it as dependency again.

Or just 'dnf remove nss-pem' after successful upgrade as nss-pem will likely not be a dependency of anything any more.

Comment 15 Kamil Dudka 2018-05-23 11:13:00 UTC
*** Bug 1553646 has been marked as a duplicate of this bug. ***

Comment 16 Antonin 2018-05-23 11:42:07 UTC
(In reply to Marek Blaha from comment #13)
> (In reply to Antonin from comment #12)
> > > # dnf install nss-pem-1.0.3-9.fc28
> > 
> > But I think it will change status of the nss-pem package from "installed as
> > dependency" to "user installed". If possible I would avoid it.
> 
> You can run # dnf mark remove nss-pem to mark it as dependency again.

I didn't know about it. I will try it. Thanks.

Comment 17 Jos de Kloe 2018-05-24 07:02:54 UTC
(In reply to Kamil Dudka from comment #14)
> (In reply to Marek Blaha from comment #13)
> > You can run # dnf mark remove nss-pem to mark it as dependency again.
> 
> Or just 'dnf remove nss-pem' after successful upgrade as nss-pem will likely
> not be a dependency of anything any more.

that's not entirely the case on my side ...

I get:

sudo dnf remove remove nss-pem
No match for argument: remove
Dependencies resolved.
==========================================================================================
 Package                           Arch         Version              Repository      Size
==========================================================================================
Removing:
 nss-pem                           x86_64       1.0.3-9.fc28         @fedora        215 k
Removing dependent packages:
 abrt-addon-ccpp                   x86_64       2.10.8-2.fc28        @fedora        325 k
 abrt-addon-pstoreoops             x86_64       2.10.8-2.fc28        @fedora         15 k
 abrt-addon-vmcore                 x86_64       2.10.8-2.fc28        @fedora         45 k
 abrt-cli                          x86_64       2.10.8-2.fc28        @fedora          0  
 abrt-desktop                      x86_64       2.10.8-2.fc28        @fedora          0  
 abrt-retrace-client               x86_64       2.10.8-2.fc28        @fedora        110 k
 gnome-abrt                        x86_64       1.2.6-3.fc28         @fedora        858 k
Removing unused dependencies:
 abrt-addon-coredump-helper        x86_64       2.10.8-2.fc28        @fedora         43 k
 abrt-addon-kerneloops             x86_64       2.10.8-2.fc28        @fedora         80 k
 abrt-addon-xorg                   x86_64       2.10.8-2.fc28        @fedora         53 k
 abrt-gui                          x86_64       2.10.8-2.fc28        @fedora        227 k
 abrt-gui-libs                     x86_64       2.10.8-2.fc28        @fedora         28 k
 abrt-plugin-bodhi                 x86_64       2.10.8-2.fc28        @fedora         27 k
 abrt-tui                          x86_64       2.10.8-2.fc28        @fedora         31 k
 libreport-fedora                  x86_64       2.9.5-1.fc28         @updates        47 k
 libreport-plugin-kerneloops       x86_64       2.9.5-1.fc28         @updates        38 k
 libreport-plugin-logger           x86_64       2.9.5-1.fc28         @updates        41 k
 python3-humanize                  noarch       0.5.1-11.fc28        @fedora         42 k

Transaction Summary
==========================================================================================
Remove  19 Packages

Freed space: 2.2 M
Is this ok [y/N]: n
Operation aborted.

Comment 18 Kamil Dudka 2018-05-24 10:10:49 UTC
Sorry, I forgot about abrt.  This is currently being fixed in abrt upstream:

https://github.com/abrt/abrt/pull/1305

Comment 19 Mike Kwong 2018-05-26 19:25:52 UTC
dnf install nss-pem-1.0.3-9.fc28 didn't work for me
ended up an error that says
No match for argument nss-pem-1.0.3-9.fc28

Also, having to rely on a workaround for when a widely used component (Wine) is installed seems like a really bad user experience.

Comment 20 Mike Kwong 2018-05-26 19:29:24 UTC
Looks like nss-pem-0:1.0.3-9.fc28.x86_64 is in the repository. Is this what I should try?
dnf install nss-pem-0:1.0.3-9.fc28.x86_64

Comment 21 Mike Kwong 2018-05-26 19:40:46 UTC
My bad, looks like I need
dnf install nss-pem-1.0.3-9.fc28 --releasever=28

Comment 22 Geoff Goas 2018-06-28 18:07:02 UTC
I had this issue updating F27 to F28.

The workaround in comment 21 successfully got me past it.

Comment 23 Scott Schmit 2018-08-26 21:57:01 UTC
This workaround wasn't quite enough for me.

I hit a case where "dnf system-upgrade download" downloaded what it thought was a complete set of packages but then the upgrade after "dnf system-upgrade reboot" failed due to packages that it thought needed to be downloaded to satisfy dependendencies -- all these packages were i686 packages but there were (in the end) 0 i686 packages installed.

Detailed story of what I did/tried:

I started with a completely up-to-date F27 system and tried to do a system-upgrade to F28.

Initially, my situation appeared to match that of bug 1553646 (I got the inferior package error and had steam installed).  My (attempted) fix was to uninstall the package:

dnf erase nss-pem.i686

This uninstalled steam, but I figured I could reinstall it after the upgrade.

The dnf system-update was successful, but the post-reboot upgrade failed:

dnf[1079]: ================================================================================
dnf[1079]: Install   142 Packages
dnf[1079]: Upgrade  2581 Packages
dnf[1079]: Remove      4 Packages
dnf[1079]: Total size: 3.8 G
dnf[1079]: Total download size: 8.4 M
dnf[1079]: Downloading Packages:
dnf[1079]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/python3-3.6.5-1.fc28.i686.rpm
dnf[1079]: Package "python3-3.6.5-1.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1079]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/python3-libs-3.6.5-1.fc28.i686.rpm
dnf[1079]: Package "python3-libs-3.6.5-1.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1079]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/gdbm-1.14.1-4.fc28.i686.rpm
dnf[1079]: Package "gdbm-1:1.14.1-4.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1079]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/gdbm-libs-1.14.1-4.fc28.i686.rpm
dnf[1079]: Package "gdbm-libs-1:1.14.1-4.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1079]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/readline-7.0-11.fc28.i686.rpm
dnf[1079]: Package "readline-7.0-11.fc28.i686" from repository "updates" has incorrect checksum
dnf[1079]: Error: Some packages have invalid cache, but cannot be downloaded due to "--cacheonly" option
systemd[1]: dnf-system-upgrade.service: Main process exited, code=exited, status=1/FAILURE
systemd[1]: Failed to start System Upgrade using DNF.

My first reaction was that the downloaded files must've been corrupted somehow, so I cleaned & tried again, but got the same result.
Then I looked at the file paths cited, only to find that the files were entirely missing.

So I tried again without cleaning first, but no additional files were downloaded.  The resulting reboot also failed for the same reason.

So then I tried uninstalling *all* i686 packages, cleaning, and trying again.  Again the system-update download was successful, but on reboot, I got this instead:

[Note: these are the only i686 packages listed in the dnf report and I'd already done a "rpm -qa --qf '%{NAME}.%{ARCH}\n'|grep '\.i686$'" to make sure all the i686 packages were uninstalled before I rebooted]
...
dnf[1913]: Installing dependencies:
dnf[1913]:  bzip2-libs                        i686   1.0.6-26.fc28           fedora   47 k
dnf[1913]:  expat                             i686   2.2.5-3.fc28            fedora  108 k
dnf[1913]:  gdbm                              i686   1:1.14.1-4.fc28         fedora  124 k
dnf[1913]:  gdbm-libs                         i686   1:1.14.1-4.fc28         fedora   60 k
dnf[1913]:  glibc                             i686   2.27-30.fc28            updates 3.4 M
dnf[1913]:  keyutils-libs                     i686   1.5.10-6.fc28           fedora   33 k
dnf[1913]:  krb5-libs                         i686   1.16.1-13.fc28          updates 898 k
dnf[1913]:  libcom_err                        i686   1.44.2-0.fc28           updates  46 k
dnf[1913]:  libffi                            i686   3.1-16.fc28             fedora   34 k
dnf[1913]:  libnsl2                           i686   1.2.0-2.20180605git4a062cf.fc28   
dnf[1913]:                                                                   updates  59 k
dnf[1913]:  libselinux                        i686   2.8-1.fc28              updates 183 k
dnf[1913]:  libsepol                          i686   2.8-1.fc28              updates 364 k
dnf[1913]:  libtirpc                          i686   1.0.3-3.rc2.fc28        updates 118 k
dnf[1913]:  libverto                          i686   0.3.0-5.fc28            fedora   24 k
dnf[1913]:  libxcrypt                         i686   4.1.1-4.fc28            updates  73 k
dnf[1913]:      replacing  libcrypt-nss.x86_64 2.26-28.fc27  
dnf[1913]:  ncurses-libs                      i686   6.1-5.20180224.fc28     updates 324 k
dnf[1913]:  openssl-libs                      i686   1:1.1.0h-3.fc28         fedora  1.3 M
dnf[1913]:  pcre2                             i686   10.31-8.fc28            updates 238 k
dnf[1913]:  python3-libs                      i686   3.6.5-1.fc28            fedora  7.9 M
dnf[1913]:  readline                          i686   7.0-11.fc28             updates 205 k
dnf[1913]:  sqlite-libs                       i686   3.22.0-4.fc28           fedora  584 k
dnf[1913]:  xz-libs                           i686   5.2.4-2.fc28            updates  97 k
dnf[1913]:  zlib                              i686   1.2.11-8.fc28           updates 100 k
dnf[1913]: Installing weak dependencies:
dnf[1913]:  openssl-pkcs11                    i686   0.4.8-1.fc28            updates  65 k
dnf[1913]:  python3                           i686   3.6.5-1.fc28            fedora   71 k
dnf[1913]: Removing:
dnf[1913]:  kernel                            x86_64 4.17.12-100.fc27        @updates
dnf[1913]:                                                                             0
dnf[1913]:  kernel-core                       x86_64 4.17.12-100.fc27        @updates
dnf[1913]:                                                                            59 M
dnf[1913]:  kernel-devel                      x86_64 4.17.12-100.fc27        @updates
dnf[1913]:                                                                            48 M
dnf[1913]:  kernel-modules                    x86_64 4.17.12-100.fc27        @updates
dnf[1913]:                                                                            27 M
dnf[1913]: Transaction Summary
dnf[1913]: ================================================================================
dnf[1913]: Install   156 Packages
dnf[1913]: Upgrade  2463 Packages
dnf[1913]: Remove      4 Packages
dnf[1913]: Total size: 3.7 G
dnf[1913]: Total download size: 16 M
dnf[1913]: Downloading Packages:
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/python3-3.6.5-1.fc28.i686.rpm
dnf[1913]: Package "python3-3.6.5-1.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/glibc-2.27-30.fc28.i686.rpm
dnf[1913]: Package "glibc-2.27-30.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/python3-libs-3.6.5-1.fc28.i686.rpm
dnf[1913]: Package "python3-libs-3.6.5-1.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/ncurses-libs-6.1-5.20180224.fc28.i686.rpm
dnf[1913]: Package "ncurses-libs-6.1-5.20180224.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/bzip2-libs-1.0.6-26.fc28.i686.rpm
dnf[1913]: Package "bzip2-libs-1.0.6-26.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/expat-2.2.5-3.fc28.i686.rpm
dnf[1913]: Package "expat-2.2.5-3.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/gdbm-1.14.1-4.fc28.i686.rpm
dnf[1913]: Package "gdbm-1:1.14.1-4.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/gdbm-libs-1.14.1-4.fc28.i686.rpm
dnf[1913]: Package "gdbm-libs-1:1.14.1-4.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/libffi-3.1-16.fc28.i686.rpm
dnf[1913]: Package "libffi-3.1-16.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/openssl-libs-1.1.0h-3.fc28.i686.rpm
dnf[1913]: Package "openssl-libs-1:1.1.0h-3.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/sqlite-libs-3.22.0-4.fc28.i686.rpm
dnf[1913]: Package "sqlite-libs-3.22.0-4.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/zlib-1.2.11-8.fc28.i686.rpm
dnf[1913]: Package "zlib-1.2.11-8.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/libnsl2-1.2.0-2.20180605git4a062cf.fc28.i686>
dnf[1913]: Package "libnsl2-1.2.0-2.20180605git4a062cf.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/libtirpc-1.0.3-3.rc2.fc28.i686.rpm
dnf[1913]: Package "libtirpc-1.0.3-3.rc2.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/libxcrypt-4.1.1-4.fc28.i686.rpm
dnf[1913]: Package "libxcrypt-4.1.1-4.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/readline-7.0-11.fc28.i686.rpm
dnf[1913]: Package "readline-7.0-11.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/xz-libs-5.2.4-2.fc28.i686.rpm
dnf[1913]: Package "xz-libs-5.2.4-2.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/krb5-libs-1.16.1-13.fc28.i686.rpm
dnf[1913]: Package "krb5-libs-1.16.1-13.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/keyutils-libs-1.5.10-6.fc28.i686.rpm
dnf[1913]: Package "keyutils-libs-1.5.10-6.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/fedora-f21308f6293b3270/packages/libverto-0.3.0-5.fc28.i686.rpm
dnf[1913]: Package "libverto-0.3.0-5.fc28.i686" from repository "fedora" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/libcom_err-1.44.2-0.fc28.i686.rpm
dnf[1913]: Package "libcom_err-1.44.2-0.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/libselinux-2.8-1.fc28.i686.rpm
dnf[1913]: Package "libselinux-2.8-1.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/libsepol-2.8-1.fc28.i686.rpm
dnf[1913]: Package "libsepol-2.8-1.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/pcre2-10.31-8.fc28.i686.rpm
dnf[1913]: Package "pcre2-10.31-8.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error opening file for checksum: /var/lib/dnf/system-upgrade/updates-8bd9ef368505a5fd/packages/openssl-pkcs11-0.4.8-1.fc28.i686.rpm
dnf[1913]: Package "openssl-pkcs11-0.4.8-1.fc28.i686" from repository "updates" has incorrect checksum
dnf[1913]: Error: Some packages have invalid cache, but cannot be downloaded due to "--cacheonly" option
systemd[1]: dnf-system-upgrade.service: Main process exited, code=exited, status=1/FAILURE
systemd[1]: Failed to start System Upgrade using DNF.

So this made my situation worse, not better.  (Incidentally, looking at prior boots, the missing packages were listed under "installed for dependencies" too)

I'm at a loss as to why "dnf system-upgrade download" thought the transaction was complete, but the dnf system-upgrade service after "dnf system-upgrade reboot" believed more packages needed to be installed -- especially i686 packages when there weren't any i686 packages installed.

My fix, inspired by the bug report at bug 1553646 was the following (all 3 were needed -- the first 2 alone also failed):
# dnf install steam
# dnf install nss-pem-1.0.3-9.fc28.i686 --releasever=28
# dnf upgrade python3-3.6.5-1.fc28 python3-libs gdbm gdbm-libs readline --releasever=28

after this, the system-upgrade download & system-upgrade reboot was finally successful.  Fortunately, these installs/upgrades didn't break my F27 install before I could get the rest of the system upgraded.

Comment 24 Kamil Dudka 2019-01-14 13:52:30 UTC
*** Bug 1665531 has been marked as a duplicate of this bug. ***

Comment 25 Tom McKay 2019-04-02 11:23:34 UTC
Encountering this, is there a resolution in the works?

Comment 26 Ben Cotton 2019-05-02 19:43:45 UTC
This message is a reminder that Fedora 28 is nearing its end of life.
On 2019-May-28 Fedora will stop maintaining and issuing updates for
Fedora 28. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora 'version' of '28'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 28 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 27 Jaroslav Mracek 2019-05-14 18:44:08 UTC
Please can anyone provide a reproducer with latest dnf-4.2.5 on Fedora29+?

Comment 28 Kamil Dudka 2019-05-15 08:09:17 UTC
(In reply to Jaroslav Mracek from comment #27)
> Please can anyone provide a reproducer with latest dnf-4.2.5 on Fedora29+?

Sure thing!

root@f30 ~ # rpm -q dnf
dnf-4.2.5-1.fc30.noarch

root@f30 ~ # dnf install -y https://kojipkgs.fedoraproject.org//packages/nss-pem/1.0.4/2.fc30/i686/nss-pem-1.0.4-2.fc30.i686.rpm https://kojipkgs.fedoraproject.org//packages/nss-pem/1.0.4/2.fc30/x86_64/nss-pem-1.0.4-2.fc30.x86_64.rpm
Last metadata expiration check: 0:03:16 ago on Wed 15 May 2019 10:03:35 AM CEST.
nss-pem-1.0.4-2.fc30.i686.rpm                  89 kB/s |  78 kB     00:00    
nss-pem-1.0.4-2.fc30.x86_64.rpm                83 kB/s |  74 kB     00:00    
Dependencies resolved.
==============================================================================
 Package        Architecture  Version               Repository           Size
==============================================================================
Installing:
 nss-pem        i686          1.0.4-2.fc30          @commandline         78 k
 nss-pem        x86_64        1.0.4-2.fc30          @commandline         74 k

Transaction Summary
==============================================================================
Install  2 Packages

Total size: 153 k
Installed size: 1.1 M
Downloading Packages:
Running transaction check
Transaction check succeeded.
Running transaction test
Transaction test succeeded.
Running transaction
  Preparing        :                                                      1/1 
  Installing       : nss-pem-1.0.4-2.fc30.x86_64                          1/2 
  Installing       : nss-pem-1.0.4-2.fc30.i686                            2/2 
  Running scriptlet: nss-pem-1.0.4-2.fc30.i686                            2/2 
  Verifying        : nss-pem-1.0.4-2.fc30.i686                            1/2 
  Verifying        : nss-pem-1.0.4-2.fc30.x86_64                          2/2 

Installed:
  nss-pem-1.0.4-2.fc30.i686            nss-pem-1.0.4-2.fc30.x86_64           

Complete!

root@f30 ~ # dnf update nss-pem                                            
Last metadata expiration check: 0:03:32 ago on Wed 15 May 2019 10:03:35 AM CEST.
Dependencies resolved.

 Problem: package nss-pem-1.0.5-1.fc30.x86_64 conflicts with nss-pem(x86-32) < 1.0.5-1.fc30 provided by nss-pem-1.0.4-2.fc30.i686
  - package nss-pem-1.0.5-1.fc30.x86_64 obsoletes nss-pem < 1.0.5-1.fc30 provided by nss-pem-1.0.4-2.fc30.i686
  - cannot install the best update candidate for package nss-pem-1.0.4-2.fc30.x86_64
  - problem with installed package nss-pem-1.0.4-2.fc30.i686
==============================================================================
 Package          Architecture    Version               Repository       Size
==============================================================================
Skipping packages with conflicts:
(add '--best --allowerasing' to command line to force their upgrade):
 nss-pem          x86_64          1.0.5-1.fc30          fedora           74 k

Transaction Summary
==============================================================================
Skip  1 Package

Nothing to do.
Complete!

root@f30 ~ # dnf install nss-pem-1.0.5-1.fc30.x86_64
Last metadata expiration check: 0:03:47 ago on Wed 15 May 2019 10:03:35 AM CEST.
Dependencies resolved.
==============================================================================
 Package          Architecture    Version               Repository       Size
==============================================================================
Upgrading:
 nss-pem          x86_64          1.0.5-1.fc30          fedora           74 k
     replacing  nss-pem.i686 1.0.4-2.fc30

Transaction Summary
==============================================================================
Upgrade  1 Package

Total download size: 74 k
Is this ok [y/N]:

Comment 29 Jaroslav Mracek 2019-09-06 16:00:01 UTC
The issue is reproducible. I create an issue on libsolv https://github.com/openSUSE/libsolv/issues/350, probably they will have a solution.

At least dnf suggest to use allowerasing option to resolve the issue.


Note You need to log in before you can comment on or make changes to this bug.